View Issue Details

IDProjectCategoryView StatusLast Update
0006430Talermechant backendpublic2021-09-02 18:23
ReporterMS Assigned Tojonathanbuchanan  
PriorityhighSeveritymajorReproducibilityhave not tried
Status closedResolutionfixed 
Product Versiongit (master) 
Target Version0.8Fixed in Version0.8 
Summary0006430: Responds with 404 for unclaimed orders.
DescriptionThe merchant responds with 404 when a unclaimed (existing!) order is requested
via the GET /private/orders/$ID API. It needs to be fixed to return a object that informs
the requester about the status of the order (as the documentation also suggests).

Merchant test cases got also extended to reproduce this problem.
Steps To ReproduceRun: test_merchant_api
TagsNo tags attached.

Activities

Christian Grothoff

2020-07-16 19:34

manager   ~0016471

Just to clarify: this implies looking in the 'orders' table and not only in the 'contracts' table. I thought we implemented this, but maybe not. To be verified.

Christian Grothoff

2020-07-16 19:35

manager   ~0016472

On my list, but Jonathan: if you get to it first, also great ;-).

jonathanbuchanan

2020-07-16 22:23

developer   ~0016480

I'll work on this. Looks pretty easy to fix on the backend side, but the backend adds some fields to the contract_terms json, so the testing library will have to correctly add all those so we can generate the correct hash for when we look up the order.

Christian Grothoff

2020-07-16 22:57

manager   ~0016481

Actually, in this case you MUST NOT generate a contract hash, as for unclaimed orders such a contract hash is meaningless. So the response in this case must be without a contract hash. (That's why we use the term 'order': an order cannot have a contract hash, but a contract has one!). A payment begins with an order, and once claimed we have the contract terms and the hash.

jonathanbuchanan

2020-07-16 23:07

developer   ~0016484

Oops. I was looking at the wallet code instead of the merchant code.

jonathanbuchanan

2020-07-16 23:09

developer   ~0016485

fixed in 90adbb3..6c04f55.

jonathanbuchanan

2021-09-02 18:23

developer   ~0018375

Fix committed to master branch.

Related Changesets

merchant: master 6c04f551

2020-07-16 23:03:07

jonathanbuchanan

Details Diff
fix 0006430 Affected Issues
0006430
mod - src/backend/taler-merchant-httpd_private-get-orders-ID.c Diff File
mod - src/testing/test_merchant_api.c Diff File
mod - src/testing/testing_api_cmd_post_orders.c Diff File

Issue History

Date Modified Username Field Change
2020-07-16 18:38 MS New Issue
2020-07-16 18:38 MS Status new => assigned
2020-07-16 18:38 MS Assigned To => Marcello Stanisci
2020-07-16 18:38 MS Assigned To Marcello Stanisci => Christian Grothoff
2020-07-16 19:34 Christian Grothoff Note Added: 0016471
2020-07-16 19:35 Christian Grothoff Priority normal => high
2020-07-16 19:35 Christian Grothoff Severity minor => major
2020-07-16 19:35 Christian Grothoff Product Version => git (master)
2020-07-16 19:35 Christian Grothoff Target Version => 0.8
2020-07-16 19:35 Christian Grothoff Note Added: 0016472
2020-07-16 22:23 jonathanbuchanan Note Added: 0016480
2020-07-16 22:57 Christian Grothoff Note Added: 0016481
2020-07-16 23:07 jonathanbuchanan Note Added: 0016484
2020-07-16 23:09 jonathanbuchanan Status assigned => resolved
2020-07-16 23:09 jonathanbuchanan Resolution open => fixed
2020-07-16 23:09 jonathanbuchanan Note Added: 0016485
2020-07-24 11:56 Christian Grothoff Fixed in Version => 0.8
2021-08-24 16:23 Christian Grothoff Status resolved => closed
2021-09-02 18:22 jonathanbuchanan Changeset attached => Taler-merchant master 6c04f551
2021-09-02 18:23 jonathanbuchanan Note Added: 0018375
2021-09-02 18:23 jonathanbuchanan Assigned To Christian Grothoff => jonathanbuchanan